# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if "%{?rhel}" == "6"
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif
%else
%bcond_with repolib
%endif

# XXX: circular dependency
%bcond_without istack_commons

%define reltag _opensuse_2
%define namedreltag -opensuse-2
%global namedversion %{version}%{?namedreltag}

%define section free

%define maven_version 2.6-opensuse-2

Name:           sun-codemodel
Version:        2.6
Release:        3%{?reltag}%{?dist}.3
Epoch:          0
Summary:        Java source code generation library
License:        CDDL
URL:            https://codemodel.dev.java.net/
Group:          Development/Java

%if %with mead
Source100: com.sun.codemodel-codemodel-project-2.6-opensuse-2-sources.zip
Source101: com.sun.codemodel-codemodel-project-2.6-opensuse-2-patches.zip
Source102: codemodel-annotation-compiler-2.6-opensuse-2.jar
Source103: codemodel-annotation-compiler-2.6-opensuse-2-sources.jar
Source104: codemodel-annotation-compiler-2.6-opensuse-2.pom
Source105: codemodel-project-2.6-opensuse-2-javadoc.jar
Source106: codemodel-project-2.6-opensuse-2.pom
Source107: codemodel-2.6-opensuse-2.jar
Source108: codemodel-2.6-opensuse-2-sources.jar
Source109: codemodel-2.6-opensuse-2.pom
%endif

%if %without mead
# git clone git://git.app.eng.bos.redhat.com/codemodel.git
# cd codemodel && git checkout 11148247917eefcb14f60f3766a3ac6b1fa3e702 && cd ..
# HEAD is now at 1114824... remove distr management section 
# tar cjf sun-codemodel-2.6.tar.bz2 codemodel
Source0:        sun-codemodel-2.6.tar.bz2
Patch0:         codemodel-vman.patch
Patch1:         codemodel-no-istack-commons.patch
%endif
Provides:       codemodel = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils
%if %with istack_commons
Requires:       istack-commons >= 0:2.5
%if %without mead
BuildRequires:  istack-commons >= 0:2.5
%endif
%endif
%if %without mead
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  jboss-parent
BuildRequires:  jvnet-parent
BuildRequires:  junit
BuildRequires:  maven2
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  oss-parent
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Java source code generation library.

%package javadoc
Summary:        Javadoc for codemodel
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q 
%patch0 -p1 -b .sav0
%{_bindir}/find -type f -name '*.jar' | %{_bindir}/xargs -t %{__rm}
%if %without istack_commons
%{__rm} codemodel-annotation-compiler/src/main/java/com/sun/codemodel/ac/ACTask.java
%patch1 -p1 -b .sav1
%endif
%endif

%build
%if %without mead
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%define prevversion 2.5-opensuse-2
for d in `%{_bindir}/find maven2-brew -type d -name %{prevversion}`; do
    %{__mv} ${d}/* `/bin/echo ${d} | %{__sed} -e 's|%{prevversion}|%{namedversion}|;'`/
    %{__rm} -r ${d}/
done
%endif

%install
%{__rm} -rf %{buildroot}

%if 0
com/sun/codemodel/codemodel-project/2.6-opensuse-2/codemodel-project-2.6-opensuse-2-site.xml
%endif

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel-annotation-compiler/%{namedversion}/codemodel-annotation-compiler-%{namedversion}-sources.jar %{buildroot}%{_javadir}/codemodel-annotation-compiler-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel-annotation-compiler/%{namedversion}/codemodel-annotation-compiler-%{namedversion}.jar %{buildroot}%{_javadir}/codemodel-annotation-compiler-%{namedversion}.jar
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel/%{namedversion}/codemodel-%{namedversion}-sources.jar %{buildroot}%{_javadir}/codemodel-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel/%{namedversion}/codemodel-%{namedversion}.jar %{buildroot}%{_javadir}/codemodel-%{namedversion}.jar
%else
%{__cp} -p  %{_sourcedir}/codemodel-annotation-compiler-%{namedversion}-sources.jar %{buildroot}%{_javadir}/codemodel-annotation-compiler-%{namedversion}-sources.jar
%{__cp} -p  %{_sourcedir}/codemodel-annotation-compiler-%{namedversion}.jar %{buildroot}%{_javadir}/codemodel-annotation-compiler-%{namedversion}.jar
%{__cp} -p  %{_sourcedir}/codemodel-%{namedversion}-sources.jar %{buildroot}%{_javadir}/codemodel-%{namedversion}-sources.jar
%{__cp} -p  %{_sourcedir}/codemodel-%{namedversion}.jar %{buildroot}%{_javadir}/codemodel-%{namedversion}.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel-annotation-compiler/%{namedversion}/codemodel-annotation-compiler-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-codemodel-annotation-compiler.pom
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel-project/%{namedversion}/codemodel-project-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-codemodel-project.pom
%{__cp} -p maven2-brew/com/sun/codemodel/codemodel/%{namedversion}/codemodel-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-codemodel.pom
%else
%{__cp} -p %{_sourcedir}/codemodel-annotation-compiler-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-codemodel-annotation-compiler.pom
%{__cp} -p %{_sourcedir}/codemodel-project-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-codemodel-project.pom
%{__cp} -p %{_sourcedir}/codemodel-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-codemodel.pom
%endif

# depmaps
%add_to_maven_depmap com.sun.codemodel codemodel-annotation-compiler %{namedversion} JPP codemodel-annotation-compiler
%add_to_maven_depmap com.sun.codemodel codemodel-project %{namedversion} JPP codemodel-project
%add_to_maven_depmap com.sun.codemodel codemodel %{namedversion} JPP codemodel
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/codemodel

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/codemodel-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/codemodel-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/codemodel-project-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/codemodel-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/codemodel-%{namedversion}/META-INF
%endif
%{__ln_s} codemodel-%{namedversion} %{buildroot}%{_javadocdir}/codemodel

# repolib
%if %with repolib
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
cp -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE.html
%endif
%{_javadir}*/codemodel-annotation-compiler-%{namedversion}-sources.jar
%{_javadir}*/codemodel-annotation-compiler-sources.jar
%{_javadir}*/codemodel-annotation-compiler-%{namedversion}.jar
%{_javadir}*/codemodel-annotation-compiler.jar
%{_javadir}*/codemodel-%{namedversion}-sources.jar
%{_javadir}*/codemodel-sources.jar
%{_javadir}*/codemodel-%{namedversion}.jar
%{_javadir}*/codemodel.jar
%{_mavenpomdir}/JPP-codemodel-annotation-compiler.pom
%{_mavenpomdir}/JPP-codemodel-project.pom
%{_mavenpomdir}/JPP-codemodel.pom
%{_mavendepmapfragdir}/codemodel

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/codemodel-%{namedversion}
%{_javadocdir}/codemodel

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.6-3_redhat_2.3
- Rebuild for MD5

* Mon Aug 20 2012 Paul Gier <pgier@redhat.com> - 0:2.6-2_redhat_2.3
- Update pom patch to remove bom because it is inherited from external parent pom

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.6-2_redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.6-2_redhat_1.1
- Rebuild using cache signing

* Thu Jul 05 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.6-2
- Build in MEAD

* Tue May 01 2012 David Walluck <dwalluck@redhat.com> 0:2.6-1
- 2.6
- add LICENSE.html
- fix file list

* Fri Feb 24 2012 David Walluck <dwalluck@redhat.com> 0:2.5-0.2
- enable istack-commons

* Thu Feb 23 2012 David Walluck <dwalluck@redhat.com> 0:2.5-0.1
- 2.5
- build with maven
- add repolib

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 2.0-2
- Auto rebuild for JPackage 5 in mock

* Tue Mar 11 2008 Ralph Apel <r.apel at r-apel.de> 0:2.0-1jpp
- First release
